// To compile the program  # gcc -o knob knob.c -lm

// If you want call this program you need call   # knob X Y
// Where X is the value coordinate X axis pointermouse and 
// Y is the value coordinate Y axis pointer mouse.
// These values are passed by the program GtkDialog 

#include <stdio.h> 
#include <stdlib.h> 
#include <string.h>
#include <math.h>
#define PI 3.14159
#define WIN_SIZE 300  // SIZE OF WINDOW KNOB
#define RADIO 150 // THE RADIO = WIN_SIZE / 2
#define STEP 10

void get_in_degree(int val);


int main (int argc, char *argv[])
{
float RADIANS, TANG, ARCOTANG, SINE, COSEN;
int i, DEGRED, DEGR, ANGLE, X, Y;
char ch[20];
     
  if (argc > 1)     // Get the numerical values of your mouse X and Y
     { X=atoi(argv[1]); Y=atoi(argv[2]); }
      else { printf("Enter the coordinates of the mouse X and Y.\n"); }
      
   FILE *fp1;	

// THE FOLLOWING CODE IS IS TO FIND OUT WHAT ANGLE YOUR MOUSE IS, WITH THE VALUES OF X and Y CALCULATE THE ANGLE BY
// ß = arctangent (SINE / CONSEN)  ====> ß = arctangent ( Y / X ) relative.
// FOR MORE INFORMATION SEE THIS JPG FILE DIRECTORY

   SINE=(-1)*(Y-RADIO); COSEN=(-1)*(RADIO-X);

   if ( (( COSEN < 0 ) || ( COSEN > 0 )) && (( SINE > 0 ) && ( COSEN > 0 )) )
   {
       TANG=SINE/COSEN; DEGRED=180*atan(TANG)/PI;
   }      
   if ( (( COSEN < 0 ) || ( COSEN > 0 ))  && (( SINE > 0 ) && ( COSEN < 0 )) )
   {
       TANG=SINE/COSEN; DEGRED=180*atan(TANG)/PI; DEGRED=DEGRED+180;
   }   
   if ( (( COSEN < 0 ) || ( COSEN > 0 ))  && (( SINE < 0 ) && ( COSEN < 0 )) )
   {
       TANG=SINE/COSEN; DEGRED=180*atan(TANG)/PI; DEGRED=DEGRED+180;
   } 
   
   if ( (( COSEN < 0 ) || ( COSEN > 0 ))  && (( SINE < 0 ) && ( COSEN > 0 )) )
   {
       TANG=SINE/COSEN; DEGRED=180*atan(TANG)/PI; DEGRED=DEGRED+360;
   } 
   if (( COSEN < 0 ) || ( COSEN > 0 )) { i = DEGRED%10 ; 
        if ( i > 4) { DEGRED = DEGRED - i + 10; } else { DEGRED = DEGRED - i; } }
  
   if ( COSEN == 0 ) {  if ( SINE > 0) DEGRED=90; else DEGRED=270; }    // DIVISION BY ZERO AVOID COSINE
  
  // ****************************************************************   

  fp1 = fopen("/tmp/knob/DEGR.dat","r+");  // Open file with variable DEGR for change degree .
  if (fp1 == NULL)
 		exit(1);
 		
  fgets(ch,20,fp1);

  fclose(fp1);	
  
  DEGR=atoi(ch); 	
  
  
  // THE FOLLOWING CODE IS TO DETERMINE THAT ADDRESS TO TURN THE KNOB DEPENDING ON MOUSE POINTER
  
   ANGLE=240-DEGR ;  // Value of the angle where the point of the knob is
 
   if  (( DEGR < 240 ) && ( ANGLE > DEGRED) && ( ANGLE > 0))
     {
       DEGR=DEGR+STEP; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w"); fputs( ch, fp1 );fclose(fp1); get_in_degree(DEGR);    
     } 

   if  (( DEGR < 240 ) && ( ANGLE < DEGRED) && ( DEGR > 0 ) && ( DEGRED < 270 ))
     {
       DEGR=DEGR-STEP; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w"); fputs( ch, fp1 );fclose(fp1); get_in_degree(DEGR);    
     }      
   
   if  (( DEGR > 239 ) && ( DEGR < 300 ) && ( DEGR < 600 - DEGRED ) && ( DEGRED > 290 )  && ( DEGRED < 360 ))
     {
       DEGR=DEGR+STEP; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w"); fputs( ch, fp1 );fclose(fp1); get_in_degree(DEGR);    
     }        

   if  (( DEGR > 239 ) && ( DEGR < 301 ) && ( DEGR > 600 - DEGRED ) && ( DEGRED > 290 ))
     {
       DEGR=DEGR- STEP; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w"); fputs( ch, fp1 );fclose(fp1); get_in_degree(DEGR);    
     }   
      
  if  (( DEGRED < 361 ) && ( DEGRED > 290 ) && ( DEGR > -1 ) && ( DEGR < 240 ))
     {
       DEGR=DEGR+STEP; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w"); fputs( ch, fp1 );fclose(fp1); get_in_degree(DEGR);    
     }             
      
  if  (( DEGR > 239 ) && ( DEGR < 300 ) && ( DEGRED > 0 ) && ( DEGRED < 240 ))
     {
       DEGR=DEGR-STEP; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w"); fputs( ch, fp1 );fclose(fp1); get_in_degree(DEGR);    
     }             
            

} 


// The next code replace variable "DEGRED" in file  imgini.svg for rotation degree value and copy in 
//  file img.svg later use for pixmap in Gtkdialog program.        

void get_in_degree(int val)
{
const char fileimgini[32] = "/tmp/knob/imgini.svg"; // original file
const char fileimg[32] = "/tmp/knob/img.svg";   //  pixmap file to use with the angle changed
const char var1[20] = "DEGRED";
char var2[20];
		
char buffer[122];
char *buff_ptr, *find_ptr;

	FILE *fp2, *fp3;
	
  	sprintf(var2,"%d",val);
  	
 	size_t find_len = strlen(var1);

	fp2 = fopen(fileimgini,"r");
	fp3 = fopen(fileimg,"w");

	while(fgets(buffer,122,fp2))
		{
			buff_ptr = buffer;
			while ((find_ptr = strstr(buff_ptr,var1)))
				{
				while(buff_ptr < find_ptr)
				fputc((int)*buff_ptr++,fp3);
				fputs(var2,fp3);
				buff_ptr += find_len;
       }
         fputs(buff_ptr,fp3);
    }

    fclose(fp3);
    fclose(fp2);
}

